import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

public class ChessBoardGUI extends JPanel {
    public JButton[][] button = new JButton[8][8];
    private JPanel whiteRemovedPiecePanel;
    private JPanel blackRemovedPiecePanel;
    private JPanel turnPanel;
    private JButton removedPieces[][] = new JButton[8][4];
    private JLabel turnLabel = new JLabel();
    private int wORb = 0;
    private Piece pw[];
    private Piece pb[];
    private Player white;
    private Player black;
    private Cell board[][];
    private Cell source;
    private Cell dest;
    private boolean[][] moveBoard = null;
    public ArrayList<Piece> deletedList = new ArrayList<>();
    private JFrame parentPanel;
    public ChessBoardGUI(JPanel whiteRemovedPiecePanel,JPanel blackRemovedPiecePanel,JPanel turnPanel,JFrame parentPanel){
        super();
        this.whiteRemovedPiecePanel= whiteRemovedPiecePanel;
        this.blackRemovedPiecePanel = blackRemovedPiecePanel;
        this.turnPanel = turnPanel;
        this.parentPanel = parentPanel;
        parentPanel.setTitle("White Turn...");
//        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setSize(800,600);
        initlizeGame();
        inilizeRemovedPiecePanel();
        setLayout(new GridLayout(8,8));
        Piece pieceBoard[][] = getUpdatedBoard();
        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < 8; j++) {
                button[i][j] = new JButton();
                int finalI = i;
                int finalJ = j;
                if(pieceBoard[i][j]!=null)
                    button[i][j].setIcon(new ImageIcon(pieceBoard[i][j].getPieceImage()));
                button[i][j].addActionListener(new ActionListener() {
                    @Override
                    public void actionPerformed(ActionEvent e) {
//                        System.out.println(finalJ +","+ finalI);
                        source = new Cell(dest);
                        dest = new Cell(finalI,finalJ);
                        if(moveBoard!=null){
                            if(moveBoard[finalI][finalJ] && source!=null && dest!=null){
                                movePiece(source,dest);
//                                System.out.println("Moves");
                                buttonRepaint();
                                updateDeletedPanel();
                                //----------------
                                int condition = checkCondition(board,pw,pb);

                                if(condition==2){
                                    JOptionPane.showMessageDialog(turnPanel,"Condition White");
                                }
                                else if(condition==1){
                                    JOptionPane.showMessageDialog(turnPanel,"Condition Black");
                                }
                                //----------------
                            }
                        }
                        moveBoard = moves(dest);
                        if(moveBoard !=null){
                            updateGUIBoard(moveBoard);
                        }
                        if(wORb%2==0){
                            turnLabel.setText("White Turn...");
                        }else {
                            turnLabel.setText("Black Turn...");
                        }
                    }
                });
                add(button[i][j]);
                if((i+j)%2==0)
                    button[i][j].setBackground(Color.CYAN);
                else {
                    button[i][j].setBackground(Color.WHITE);
                }
            }
        }
//        setVisible(true);
    }
    private void inilizeRemovedPiecePanel(){
        for (int i = 0 ; i < 8 ;i++){
            for (int j = 0 ; j < 2 ;j++) {
                removedPieces[i][j] = new JButton();
                removedPieces[i][j].setBackground(Color.YELLOW);
//            added.setMinimumSize(new Dimension(50,50));
                whiteRemovedPiecePanel.add( removedPieces[i][j]);
                removedPieces[i][3-j] = new JButton();
                removedPieces[i][3-j].setBackground(Color.YELLOW);
                blackRemovedPiecePanel.add( removedPieces[i][3-j]);
            }
        }
        turnPanel.setLayout( new FlowLayout(FlowLayout.CENTER));
        turnPanel.add(turnLabel);
    }
    private void updateDeletedPanel(){
        int wCount = 0;
        int bCount = 0;
        for (Piece p : deletedList){
            if(p.getPieceColor()==PieceColor.WHITE) {
                int i = wCount % 8;
                int j = wCount / 8;
                wCount++;
                removedPieces[i][j].setIcon(new ImageIcon(p.getPieceImage()));
            }else {
                int i = bCount % 8;
                int j = bCount / 8;
                bCount++;
                removedPieces[i][3-j].setIcon(new ImageIcon(p.getPieceImage()));
            }
        }
    }
    private void buttonRepaint(){
        Piece[][] pieceBoard = getUpdatedBoard();
        for (int i = 0 ;i<8 ;i++){
            for (int j = 0 ; j < 8 ;j++){
                if(pieceBoard[i][j]!=null) {
                    button[i][j].setIcon(new ImageIcon(pieceBoard[i][j].getPieceImage()));
                }else {
                    button[i][j].setIcon(new ImageIcon());
                }
                if((i+j)%2==0)
                    button[i][j].setBackground(Color.CYAN);
                else {
                    button[i][j].setBackground(Color.WHITE);
                }
            }
        }
    }
    private void updateGUIBoard(boolean [][] moveBoard){
        if(moveBoard ==null) return;;
        for (int i = 0 ; i < 8 ;i++){
            for (int j =0 ; j < 8 ;j++){
                if(moveBoard[i][j]){
                    button[i][j].setBackground(Color.RED);
//                    System.out.println("Reach Thereeee...");
                } else {
                    if((i+j)%2==0)
                        button[i][j].setBackground(Color.CYAN);
                    else {
                        button[i][j].setBackground(Color.WHITE);
                    }
                }
            }
        }
    }
    public void initlizeGame(){
        white = new Player(PieceColor.WHITE) ;
        black = new Player(PieceColor.BLACK) ;
        pw = white.getPieces() ;
        pb = black.getPieces() ;
        board = new Cell[8][8] ;

        for (int i=0 ; i<8 ; ++i) {
            for (int j=0 ; j<8 ; ++j) {
                board[i][j] = new Cell (i,j) ;
            }
        }
        for (Piece p:pw) {
            board[p.getCell().getRow()][p.getCell().getCol()] = p.getCell() ;
        }
        for (Piece p:pb) {
            board[p.getCell().getRow()][p.getCell().getCol()] = p.getCell() ;
        }
    }
    public boolean[][] moves(Cell source){
        boolean[][] binaryBoard = new boolean[8][8];
        if (wORb%2==0) {
            for (Piece p : pw){
                if(!p.isDeleted() && p.getCell().getRow() == source.getRow() && p.getCell().getCol()==source.getCol()){
                    for (int i = 0 ; i < 8;i++){
                        for (int j = 0 ; j < 8 ;j++){
//                            Cell dest = new Cell(i,j);
                            if(p.isValidMove(board[i][j],board,pw,pb)){
                                binaryBoard[i][j] = true;
                            }
                        }
                    }
                    return binaryBoard;
                }
            }
        }else {
            for (Piece p : pb){
                if(!p.isDeleted() && p.getCell().getRow() == source.getRow() && p.getCell().getCol()==source.getCol()){
                    for (int i = 0 ; i < 8;i++){
                        for (int j = 0 ; j < 8 ;j++){
                            if(p.isValidMove(board[i][j],board,pw,pb)){
                                binaryBoard[i][j] = true;
                            }
                        }
                    }
                    return binaryBoard;
                }
            }
        }
        return null;
    }
    public boolean movePiece(Cell source, Cell dest){
        //--------------
        if (wORb%2==0) {
            for (Piece p : pw) {
                if (!p.isDeleted() && p.getCell().getRow() == source.getRow() &&
                        p.getCell().getCol() == source.getCol()) {
                    if (p.isValidMove(board[dest.getRow()][dest.getCol()], board, pw, pb)) {
                        dest = board[dest.getRow()][dest.getCol()];
                        wORb++;
                        board[p.getCell().getRow()][p.getCell().getCol()].setEmpty(true);
                        p.setCell(dest);
                        board[p.getCell().getRow()][p.getCell().getCol()].setEmpty(false);
                        if (p instanceof Pawn) {
                            Pawn myPawn = (Pawn) p;
                            myPawn.setOnce(false);
                        }
                        for (Piece blackPiece : pb) {
                            if (blackPiece.getCell().getRow() == dest.getRow()
                                    && blackPiece.getCell().getCol() == dest.getCol()) {
                                blackPiece.setDeleted(true);
                                deletedList.add(blackPiece);
                            }
                        }
                        return true;
                    }
                }
            }
        }else {
            for (Piece p:pb) {
                if (!p.isDeleted() && p.getCell().getRow()==source.getRow() &&
                        p.getCell().getCol() == source.getCol())
                    if (p.isValidMove(board[dest.getRow()][dest.getCol()], board, pw, pb) ) {
                        dest = board[dest.getRow()][dest.getCol()];
                        wORb++ ;
                        board[p.getCell().getRow()][p.getCell().getCol()].setEmpty(true) ;
                        p.setCell(dest) ;
                        board[p.getCell().getRow()][p.getCell().getCol()].setEmpty(false) ;
                        if (p instanceof Pawn) {
                            Pawn myPawn = (Pawn) p;
                            myPawn.setOnce(false) ;
                        }
                        for (Piece whitePiece:pw) {
                            if (whitePiece.getCell().getRow()==dest.getRow()
                                    && whitePiece.getCell().getCol()==dest.getCol()) {
                                whitePiece.setDeleted(true);
                                deletedList.add(whitePiece);
                            }
                        }
                        return true;
                    }
            }
        }

        //--------------
        return false;
    }
    public Piece[][] getUpdatedBoard(){
        Piece[][] pieceboard = new Piece[8][8];
        Piece pw[] = white.getPieces() ;
        Piece pb[] = black.getPieces() ;
        for (Piece p : pw){
            if(!p.isDeleted())
                pieceboard[p.getCell().getRow()][p.getCell().getCol()] = p;
        }
        for (Piece p : pb){
            if(!p.isDeleted())
                pieceboard[p.getCell().getRow()][p.getCell().getCol()] = p;
        }
        return pieceboard;
    }
    private int checkCondition(Cell board[][], Piece pw[], Piece pb[]) {
        for (Piece p:pw) {
            if (p instanceof King) {
                int sw1=0 ;
                for (Piece p1:pb) {
                    if (p1.isValidMove(p.getCell(), board, pw, pb)) {
                        sw1=1 ;
                    }
                }
                if(sw1==1){
                    System.out.println("Check condition for White player!!");
                    return 1;
                }
            }

        }
        for (Piece p:pb) {
            if (p instanceof King) {
                int sw1=0 ;
                for (Piece p1:pw) {
                    if (p1.isValidMove(p.getCell(), board, pw, pb)) {
                        sw1=1 ;
                    }
                }
                if(sw1==1) {
                    System.out.println("Check condition for Balck player!!") ;
                    return 2;
                }
            }
        }
        return 0;
    }
}
